unit VCLDragAndDropU;

{$ifdef Ver80} { Delphi 1.0x }
  {$define DelphiLessThan3}
{$endif}
{$ifdef Ver90} { Delphi 2.0x }
  {$define DelphiLessThan3}
{$endif}
{$ifdef Ver93} { C++ Builder 1.0x }
  {$define DelphiLessThan3}
{$endif}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, FileCtrl, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    DirLabel: TLabel;
    FileEdit: TEdit;
    FileList: TFileListBox;
    DirList: TDirectoryListBox;
    DriveCombo: TDriveComboBox;
    FilterCombo: TFilterComboBox;
    Bevel1: TBevel;
    Image: TImage;
    procedure FileListDblClick(Sender: TObject);
    procedure FileListMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ImageDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$ifndef DelphiLessThan3}
uses
  JPEG;
{$endif}

{$R *.DFM}

procedure TForm1.FileListDblClick(Sender: TObject);
begin
  Image.Picture.LoadFromFile(FileList.FileName)
end;

procedure TForm1.FileListMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Sender is TCustomListBox) and (Button = mbLeft) then
    with TCustomListBox(Sender) do
      if ItemAtPos(Point(X, Y), True) <> -1 then
        BeginDrag(False)
end;

procedure TForm1.ImageDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := Source = FileList
end;

procedure TForm1.ImageDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Assigned(FileList.OnDblClick) then
    FileList.OnDblClick(FileList)
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Color := Random($1000000);
end;

end.
